#include <euler/syscall.hpp>
#include <cstdlib>
#include <string>

int main(int argc, char **argv);

extern "C" [[noreturn]] void _start() {

  //TODO: call static initializers

  auto argc_raw = euler::syscall::try_get_environment_variable("ARGC");
  int argc = argc_raw.has_value() ? std::stoi(argc_raw.value()) : 0;

  std::vector<std::string> argv;

  for (int i = 0; i < argc; ++i) {
    std::string arg_name = std::string("ARGV") + std::to_string(i);
    auto arg_raw = euler::syscall::try_get_environment_variable(arg_name);
    argv.push_back(arg_raw.has_value() ? arg_raw.value() : "");
  }

  std::vector<char *> c_argv(argc);
  for (int i = 0; i < argc; ++i)
    c_argv[i] = argv[i].data();

  int exit_code = main(argc, c_argv.data());

  euler::syscall::end_this_process(exit_code);

}
